#include "ParamInteger.h"
#include "Utils.h"

namespace ffgl
{

ParamInteger::ParamInteger( const std::string& name, int defaultValue, const RangeStruct range ) :
	ParamInteger( name, name, defaultValue, range )
{
}

ParamInteger::ParamInteger( const std::string& name, const std::string& uniformName, int defaultValue, const RangeStruct range ) :
	ParamRange( name, ParameterType::FF_TYPE_INTEGER, uniformName, static_cast< float >( defaultValue ), { static_cast< float >( static_cast< int >( range.min ) ), static_cast< float >( static_cast< int >( range.max ) ) } )
{
}

ParamInteger::~ParamInteger()
{
}

const std::string& ParamInteger::GetDisplay() const
{
	static std::string displayString;
	displayString = std::to_string( GetIntegerValue() );
	return displayString;
}

int ParamInteger::GetIntegerValue() const
{
	// Integers are defined with a range, but the value is not normalised (0.0 to 1.0)
	return static_cast< int >( roundf( GetFloatValue() ) );
}

void ParamInteger::SetIntegerValue( int newValue )
{
	SetFloatValue( static_cast< float >( newValue ) );
}

}//End namespace ffgl